#ifndef _KGR_PATCH_BSC1133191_GENERIC_GUP_H
#define _KGR_PATCH_BSC1133191_GENERIC_GUP_H

int kgr_patch_bsc1133191_generic_gup_init(void);
static inline void kgr_patch_bsc1133191_generic_gup_cleanup(void) {}


struct vm_area_struct;
struct task_struct;
struct mm_struct;

struct page *kgr_follow_page_pte(struct vm_area_struct *vma,
		unsigned long address, pmd_t *pmd, unsigned int flags);

long kgr__get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
		unsigned long start, unsigned long nr_pages,
		unsigned int gup_flags, struct page **pages,
		struct vm_area_struct **vmas, int *nonblocking);


#ifdef CONFIG_HAVE_GENERIC_RCU_GUP
int kgr__get_user_pages_fast(unsigned long start, int nr_pages, int write,
			     struct page **pages);

#define KGR_PATCH_BSC1133191_GENERIC_GUP_FUNCS				\
	KGR_PATCH(follow_page_pte, kgr_follow_page_pte),		\
	KGR_PATCH(__get_user_pages, kgr__get_user_pages),		\
	KGR_PATCH(__get_user_pages_fast, kgr__get_user_pages_fast),	\

#else /* CONFIG_HAVE_GENERIC_RCU_GUP */

#define KGR_PATCH_BSC1133191_GENERIC_GUP_FUNCS				\
	KGR_PATCH(follow_page_pte, kgr_follow_page_pte),		\
	KGR_PATCH(__get_user_pages, kgr__get_user_pages),		\

#endif /* CONFIG_HAVE_GENERIC_RCU_GUP */

#endif /* _KGR_PATCH_BSC1133191_GENERIC_GUP_H */
